<template>
  <a-config-provider
    :theme="{
      token: {
        fontFamily: 'Roboto, sans-serif'
      }
    }"
  >
    <a-spin :spinning="!isAppLoaded" tip="Loading..." size="large">
      <a-layout class="bg-sky-50 min-h-screen p-4">
        <a-layout-content
          class="shadow rounded-2xl bg-sky-100 bg-opacity-75 flex flex-col"
        >
          <router-view v-if="isAppLoaded" />
        </a-layout-content>
      </a-layout>
    </a-spin>
  </a-config-provider>
</template>

<script setup>
import { api } from './api/api.js'
import { useMainStore } from './main-store.js'
import { ref } from 'vue'
import { message } from 'ant-design-vue'
import { useRoute, useRouter } from 'vue-router'

const router = useRouter()
const route = useRoute()
const mainStore = useMainStore()

const isAppLoaded = ref(true)

const loadAppData = async () => {
  try {
    mainStore.user = await api.users.getCurrentUser()
  } catch (e) {
    if (e.data?.code === 401 && !route.meta.isAuthOptional) {
      message.warn('You need to login to access this page.')
      await router.push({ name: 'login' })
    }
  }

  router.beforeEach(async (to, from, next) => {
    if (to.meta.isAuthOptional) {
      next()
    } else {
      if (mainStore.user) {
        next()
      } else {
        message.warn('You need to login to access this page.')
        await router.push({ name: 'login' })
      }
    }
  })

  isAppLoaded.value = true
}

loadAppData()
</script>

<style scoped></style>
